import React from "react";
import { useFuzzyResult } from "../../hooks/useFuzzyResult";
import { useFuzzyInput } from "../../hooks/useFuzzyInput";
import { usePagination } from "../../hooks/usePagination";
import PageBar from "./PageBar";
import ResultPage from "./ResultPage";
var Result = function () {
    var _a = useFuzzyResult(), fuzzyResult = _a.fuzzyResult, onSelect = _a.onSelect;
    var _b = usePagination(fuzzyResult ? Object.keys(fuzzyResult) : null), pageTuples = _b.pageTuples, getCurPageTuple = _b.getCurPageTuple, nextPage = _b.nextPage, prevPage = _b.prevPage, goToPage = _b.goToPage, getPageSection = _b.getPageSection;
    // via context could also use the input value from user
    var inputVal = useFuzzyInput().inputVal;
    return fuzzyResult && pageTuples ? (React.createElement(React.Fragment, null,
        React.createElement(ResultPage, { pageTuples: pageTuples, inputVal: inputVal, getPageSection: getPageSection, onSelect: onSelect, searchResult: fuzzyResult, goToPage: goToPage }),
        React.createElement("br", null),
        React.createElement(PageBar, { nextPage: nextPage, prevPage: prevPage, pageTuples: pageTuples, curPageTuple: getCurPageTuple(), onPageSelect: function (ind) { return goToPage(ind); } }))) : null;
};
export default Result;
