import React from "react";
import { useFuse } from "./hooks/useFuse";
import { FuzzyInputProvider } from "./hooks/useFuzzyInput";
import { FuzzyResultProvider } from "./hooks/useFuzzyResult";
import FuzzyGui from "./FuzzyGui";
// fuse specific default option
var optionsDefault = {
    //includeMatches: true,
    ignoreLocation: true,
    ignoreFieldNorm: true,
    includeScore: true,
    keys: ["label", "desc"]
};
var ZIMFuzzySearch = function (_a) {
    var data = _a.data, onSelect = _a.onSelect, _b = _a.fuseOptions, fuseOptions = _b === void 0 ? optionsDefault : _b, children = _a.children;
    var _c = useFuse(data, fuseOptions), fuseResult = _c.fuseResult, doFuseSearch = _c.doFuseSearch, groupBy = _c.groupBy;
    var _d = React.useState(""), inputVal = _d[0], setInputVal = _d[1];
    var handleInput = function (evt) {
        setInputVal(evt.currentTarget.value);
        doFuseSearch(evt.currentTarget.value, function (result) {
            var result01 = groupBy(result.map(function (val) {
                // reducing fuse result to
                return val.item;
            }), "tag");
            return result01;
        });
    };
    return (React.createElement(FuzzyInputProvider, { handleInput: handleInput, inputVal: inputVal },
        React.createElement(FuzzyResultProvider, { fuzzyResult: fuseResult && Object.keys(fuseResult).length !== 0
                ? fuseResult
                : null, onSelect: onSelect }, children ? children : React.createElement(FuzzyGui, null))));
};
export default ZIMFuzzySearch;
